openlink/core/urls.py
from django.urls import path, register_converter
from openlink.core import views
from openlink.core.views import items, mapping, projects, publish, tools, users


class FloatConverter:
    regex = r"[\d\.\d]+"

    def to_python(self, value):
        return float(value)

    def to_url(self, value):
        return "{}".format(value)


register_converter(FloatConverter, "float")


app_name = "core"
urlpatterns = [
    path("", projects.projects, name="home"),
    path("about/", views.home, name="about"),
    path("profile/<username>/", views.get_user_profile, name="user-profile"),
    path("contact/", views.contact, name="contact"),
    # projects creation
    path("projects", projects.projects, name="projects"),
    path("projects/new", projects.new_project, name="projects-new"),
    path("projects/add", projects.add_project, name="projects-add"),
    # projects tools
    path(
        "projects/<int:project_id>/tools",
        tools.list_tools_project,
        name="tools-project",
    ),
    path(
        "projects/<int:project_id>/tools/new",
        tools.select_connector_project,
        name="select-connector-project",
    ),
    path(
        "projects/<int:project_id>/tools/<str:connector>",
        tools.add_tool_project,
        name="add-tool-project",
    ),
    path(
        "projects/<int:project_id>/tools/<int:tool_id>/edit_tool",
        tools.ToolUpdate.as_view(),
        name="tools-edit-project",
    ),
    path(
        "projects/<int:project_id>/tool/<int:tool_id>",
        tools.get_tool_info_project,
        name="tool-project",
    ),
    path(
        "projects/<int:project_id>/delete/tool/<int:pk>",
        tools.delete_tool,
        name="delete_tool",
    ),
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    # projects editing
    path(
        "projects/<int:project_id>/edit",
        items.ProjectUpdate.as_view(),
        name="edit-project",
    ),
    path(
        "projects/<int:project_id>/add_user_mapping",
        users.add_user_mapping,
        name="add_user_mapping",
    ),
    path(
        "projects/<int:project_id>/manage_user",
        mapping.mapping_project_user,
        name="mapping_project_user",
    ),
    path(
        "projects/<int:project_id>/delete_user_mapping/<str:pk>",
        mapping.delete_user_mapping,
        name="delete_user_mapping",
    ),
    path("projects/<int:project_id>/", projects.details, name="projects-details"),
    path(
        "projects/<int:project_id>/delete/<str:data_type>/<int:pk>",
        projects.delete,
        name="delete",
    ),
    path(
        "projects/<int:project_id>/add_investigation",
        items.add_investigation,
        name="add-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/edit",
        items.InvestigationUpdate.as_view(),
        name="edit-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/add_study",
        items.add_study,
        name="add-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/edit",
        items.StudyUpdate.as_view(),
        name="edit-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/add_assay",
        items.add_assay,
        name="add-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/edit",
        items.AssayUpdate.as_view(),
        name="edit-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/add_data",
        items.add_data,
        name="add-data",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/edit",
        items.DataUpdate.as_view(),
        name="edit-data",
    ),
    # project investigation map_id item
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/datasets",
    #     mapping.datasets,
    #     name="datasets",
    # ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/studies",
        mapping.studies,
        name="studies",
    ),
    # project investigation map_id select mapping
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/select_data_mapping",
        mapping.select_data_mapping,
        name="select_data_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/select_assay_mapping",
        mapping.select_assay_mapping,
        name="select_assay_mapping",
    ),
    # publish
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # testé quelle route est uttilisé pour choose_meta
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_non_linked_object",
    #     mapping.choose_non_linked_object,
    #     name="choose_non_linked_object",
    # ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(

openlink/urls.py
import debug_toolbar

# from openlink.core.admin import admin_site
from django.contrib import admin
from django.contrib.auth import views
from django.urls import include, path
from rest_framework import routers

from openlink import log_manager
from openlink.core.views import api

admin.site.site_header = "OPENLINK Database administration"
admin.site.site_title = "OPENLINK administration"
admin.site.index_title = "OPENLINK Site Administration"

router = routers.DefaultRouter()
router.register(r"taskinfo", api.TaskinfoViewSet, basename="taskinfo")
router.register(r"access_mapping", api.MappingViewSet, basename="access_mapping")

urlpatterns = [
    path("__debug__/", include(debug_toolbar.urls)),
    path("", include("openlink.core.urls")),
    path("admin/", admin.site.urls),
    path("accounts/login/", log_manager.login_page, name="login"),
    path("accounts/logout/", log_manager.custom_logout, name="logout"),
    path("accounts/", include("django.contrib.auth.urls")),
    path("django-rq/", include("django_rq.urls")),
    path("oidc/", include("mozilla_django_oidc.urls")),
    path("api/", include(router.urls)),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
]

openlink/core/views/api.py
import datetime
import json
import logging

from django.db.models import Q
from django.http import JsonResponse
from openlink.core.models import Mapping, TaskInfo
from openlink.core.serializers import TaskinfoSerializer
from rest_framework import permissions, viewsets


class TaskinfoViewSet(viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = TaskInfo.objects.all()
    serializer_class = TaskinfoSerializer

    def get_queryset(self):
        queryset = TaskInfo.objects.all()
        project_id = None
        max_lenght = None
        delta_minutes = None
        if self.request.query_params.get("project_id"):
            project_id = int(self.request.query_params.get("project_id"))
        if self.request.query_params.get("max_lenght"):
            max_lenght = int(self.request.query_params.get("max_lenght"))
        if self.request.query_params.get("delta_minutes"):
            delta_minutes = int(self.request.query_params.get("delta_minutes"))
        if project_id is not None:
            queryset = queryset.filter(project__id=project_id)
        if delta_minutes is not None:
            creation_time = datetime.datetime.now() - datetime.timedelta(
                minutes=delta_minutes
            )
            queryset = queryset.filter(
                Q(start_date__gte=creation_time)
                | Q(status="queued")
                | Q(status="started")
            )
        if max_lenght is not None:
            queryset = queryset.order_by("-start_date")[:max_lenght]
        return queryset


class MappingViewSet(viewsets.ViewSet):
    def list(self, request):
        mapping_id = self.request.query_params.get("item_id")
        res = mapping_id.strip("][").split(", ")
        all_results = {}
        list_result = []
        for obj in res:
            dict = {}
            try:
                mapping_object = Mapping.objects.filter(
                    foreign_id_obj__id=obj, type="data"
                )
            except Exception as e:
                logging.debug(e)
                continue
            if mapping_object:
                connector = mapping_object[0].tool_id.get_connector(
                    self.request.session["vault_token"]
                )
                has_access = connector.check_file_access(mapping_object[0].object_id)
                dict["id"] = mapping_object[0].id
                dict["access"] = has_access
                list_result.append(dict)

        all_results["results"] = list_result
        data = json.dumps(all_results)
        return JsonResponse(data, safe=False)

openlink/core/views/users.py
import logging

from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from mozilla_django_oidc.auth import OIDCAuthenticationBackend
from openlink.core.forms import AddProjectUserForm
from openlink.core.models import MappingProjectUser, Project

logger = logging.getLogger(__name__)


class OpenLinkOIDCAuthenticationBackend(OIDCAuthenticationBackend):
    def create_user(self, claims):
        user = super(OpenLinkOIDCAuthenticationBackend, self).create_user(claims)
        user.username = claims.get("preferred_username", "")
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user

    def update_user(self, user, claims):
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user


@login_required
def get_access_level(request, project_id):
    # return current user access level for a given project
    access_level = ""
    user = request.user
    try:
        projects_list_user = Project.objects.get(
            author__user=request.user, id=project_id
        )
    except Project.DoesNotExist:
        projects_list_user = None
    if projects_list_user:
        access_level = str("administrator")
    proj_map = (
        MappingProjectUser.objects.filter(user__user=user)
        .filter(project__id=project_id)
        .values()
    )
    if proj_map.exists():
        for value in proj_map:
            access_level = value["role"]
    return access_level


@login_required
def add_user_mapping(request, *args, **kwargs):
    # Select a user to be map to the current project
    current_user = request.user
    current_proj = kwargs["project_id"]
    data_type = "project"
    mpu_list = MappingProjectUser.objects.filter(project__id=current_proj)
    project = get_object_or_404(Project, id=current_proj)

    if request.method == "POST":
        form = AddProjectUserForm(request.POST)
        user_mapping = form.save(commit=False)
        user_mapping.name = str(current_proj) + "_" + str(form.cleaned_data.get("user"))
        user_mapping.project = project
        user_mapping.save()
        messages.info(request, "User " + str(form.cleaned_data.get("user")) + " added")

        return HttpResponseRedirect(
            reverse("core:add_user_mapping", args=[current_proj])
        )

    else:
        form = AddProjectUserForm()

    return render(
        request,
        "mapping/add_user_mapping.html",
        {
            "form": form,
            "current_proj": current_proj,
            "data_type": data_type,
            "current_user": current_user,
            "data_type": data_type,
            "mpu_list": mpu_list,
            "project": project,
        },
    )

openlink/core/templates/projects/display_tree.html
{% load url_link %}
{% load define %}
{% load contains_assay %}
{% load guardian_tags %}
{% load has_access_url %}
{% load get_item %}


<ul style="padding-left: 2rem; list-style-type: none;">
    <li>
    {% for investigation in items|get_item:"investigations" %}
        <div class="row no-gutters">
            <div class="col-sm-7">
                <div class="btn-group">
                    <h5><a data-toggle="collapse" href="#investigation_{{ investigation|get_item:"id" }}" aria-expanded="false"><i
                                class="fa fa-plus pull-right"></i><i class="fa fa-minus pull-right"></i>
                        </a>&nbsp;<i class="fas fa-feather"></i>&nbsp;<a
                            href="{% url 'core:edit-investigation' project_id=project.id investigation_id=investigation|get_item:"id" %}">{{investigation|get_item:"name"|truncatechars:40}}</a>&nbsp;
                        {% for mappings in investigation|get_item:"mappings" %}
                        {% if mappings|get_item:"url" %}
                        <a class="btn-xs btn rounded btn-outline-dark" role=button href="{{ mappings|get_item:"url" }}"
                            target="_blank">{{mappings|get_item:"tool"|lower}}</a>
                        {% else %}
                        <a class="btn-xs btn rounded btn-outline-dark" role=button>{{mappings|get_item:"tool"|lower}}</a>
                        {% endif %}
                        {% endfor %}
                        {% if "change_project" in perms %}
                        <a class="btn btn-outline-primary  btn-sm"
                        href="{% url 'core:add-study' project.id investigation|get_item:"id" %}"><i class="fas fa-plus"></i></a>
                        {% endif %}
                        {% if "change_project" in perms %}
                        <a class="btn btn-outline-dark btn-sm"
                            href='{% url 'core:delete' project_id=project.id investigation_id=investigation|get_item:"id" data_type="investigation" pk=investigation|get_item:"id"  %}'><i
                                class="fas fa-trash-alt" aria-hidden="true"></i></a>
                        {% else %}
                        <div class="disabled-button-wrapper" data-toggle="popover" data-trigger="hover"
                            data-placement="right" title="Action not available" data-container="body" data-html="true"
                            data-content="You don't have sufficient permissions to  <br/> <strong>delete investigation</strong>.">
                            <button class="btn btn-outline-dark btn-sm" type="button" disabled><i class="fas fa-delete"
                                    aria-hidden="true"></i></button>
                        </div>
                        {% endif %}    
                    </h5>
                </div>
            </div>
        </div>
        <ul style="padding-left: 0rem;" id="investigation_{{investigation|get_item:"id"}}" class="collapse hide">
            <ul style="padding-left: 2rem; list-style-type: none;">
            {% with investigation_id=investigation|get_item:"id" %}
            {% for studies in investigation|get_item:"studies" %}
            <li>
            <div class="tree">
                
                    <div class="row">
                        <div class="col-sm-12">
                            <h5><a data-toggle="collapse" href="#study_{{studies|get_item:"id"}}" aria-expanded="false"><i
                                        class="fa fa-plus pull-right"></i><i class="fa fa-minus pull-right"></i>
                                </a>&nbsp;<i class="fa fa-folder folder"></i>&nbsp;<a
                                    href="{% url 'core:edit-study' project_id=project.id investigation_id=investigation_id study_id=studies|get_item:"id" %}">{{studies|get_item:"name"|truncatechars:40}}</a>&nbsp;
        
                                {% for mappings in studies|get_item:"mappings" %}
                                {% if mappings|get_item:"url" %}
                                <a class="btn-xs btn rounded btn-outline-dark" role=button href="{{mappings|get_item:"url"}}"
                                    target="_blank">{{mappings|get_item:"tool"|lower}}</a>
                                {% else %}
                                <a class="btn-xs btn rounded btn-outline-dark" role=button>{{mappings|get_item:"tool"|lower}}</a>
                                {% endif %}
                                {% endfor %}
                                {% if "change_project" in perms %}
                                <a class="btn btn-outline-primary  btn-sm"
                                href="{% url 'core:add-assay' project.id investigation_id studies|get_item:"id" %}"><i class="fas fa-plus"></i></a>
                                {% endif %}
                                {% if "change_project" in perms %}
                                <a class="btn-sm btn rounded btn-outline-dark " role=button
                                    href='{% url 'core:delete' project_id=project.id investigation_id=investigation_id data_type="study" pk=studies|get_item:"id"  %}'><i
                                        class="fas fa-trash-alt" aria-hidden="true"></i></a>
                                {% else %}
                                <div class="disabled-button-wrapper" data-toggle="popover" data-trigger="hover"
                                    data-placement="right" title="Action not available" data-container="body" data-html="true"
                                    data-content="You don't have sufficient permissions to  <br/> <strong>delete study</strong>.">
                                    <button class="btn-sm btn rounded btn-outline-dark " type="button" disabled><i
                                            class="fas fa-trash-alt" aria-hidden="true"></i></button>
                                </div>
                                {% endif %}
                            </h5>
                        </div>
                    </div>
                
                <ul style="padding-left: 0rem;" id="study_{{studies|get_item:"id"}}" class="collapse hide">
                    <ul style="padding-left: 2rem; list-style-type: none;">
                        {% for assay in studies|get_item:"assays" %}
                            <li>
                                <div class="row">
                                    <div class="col-sm-12">
                                        <h5><a data-toggle="collapse" href="#assay_{{assay|get_item:"id"}}" aria-expanded="false"><i
                                                    class="fa fa-plus pull-right"></i><i class="fa fa-minus pull-right"></i>
                                            </a>&nbsp;<i class="fa fa-flask experiment"></i>&nbsp;<a
                                                href="{% url 'core:edit-assay' project_id=project.id investigation_id=investigation_id assay_id=assay|get_item:"id" %}">{{assay|get_item:"name"|truncatechars:40}}</a>&nbsp;
                    
                    
                                            {% for mappings in assay|get_item:"mappings" %}
                                            {% if mappings|get_item:"url" %}
                                            <a class="btn btn-outline-dark btn-xs rounded" class="btn-sm btn rounded" role=button
                                                href="{{mappings|get_item:"url"}}" target="_blank">{{mappings|get_item:"tool"|lower}}</a>
                                            {% else %}
                                            <a class="btn-xs btn rounded btn-outline-dark" role=button>{{mappings|get_item:"tool"|lower}}</a>
                                            {% endif %}
                                            {% endfor %}
                                            {% if "change_project" in perms %}
                                            <a class="btn btn-outline-primary  btn-sm"
                                            href="{% url 'core:add-data' project.id investigation_id assay|get_item:"id" %}"><i class="fas fa-plus"></i></a>
                                            {% endif %}
                                            {% if "change_project" in perms %}
                                            <a class="btn btn-outline-dark btn-sm rounded"
                                                href='{% url 'core:delete' project_id=project.id investigation_id=investigation_id data_type="assay" pk=assay|get_item:"id"  %}'><i
                                                    class="fas fa-trash-alt" aria-hidden="true"></i></a>
                                            {% else %}
                                            <div class="disabled-button-wrapper" data-toggle="popover" data-trigger="hover"
                                                data-placement="right" title="Action not available" data-container="body" data-html="true"
                                                data-content="You don't have sufficient permissions to  <br/> <strong>delete this assay</strong>.">
                                                <button class="btn btn-outline-dark btn-sm rounded " type="button" disabled><i
                                                        class="fas fa-trash-alt" aria-hidden="true"></i></button>
                                            </div>
                                            {% endif %}
                                        </h5>
                                    </div>
                                </div>
                            
                                    <ul style="padding-left: 0rem;" id="assay_{{assay|get_item:"id"}}" class="collapse hide">
                                        <ul style="padding-left: 2rem; list-style-type: none;">
                                        {% for data in assay|get_item:"datas" %}
                                            <li>
                                                <h5><i class="fa fa-database image"></i>&nbsp;<a
                                                    href="{% url 'core:edit-data' project_id=project.id investigation_id=investigation_id data_id=data|get_item:"id" %}">{{data|get_item:"name"|truncatechars:40}}</a>&nbsp;
                                
                                                {% for mappings in data|get_item:"mappings" %}
                                                {% if mappings|get_item:"url" %}
                                                <a class="btn btn-outline-dark btn-xs rounded" role=button href="{{mappings|get_item:"url"}}"
                                                    target="_blank">{{mappings|get_item:"tool"|lower}}</a>
                                                {% else %}
                                                <a class="btn-xs btn rounded btn-outline-dark" role=button>{{mappings|get_item:"tool"|lower}}</a>
                                                {% endif %}
                                                {% endfor %}
                                
                                                {% if "change_project" in perms %}
                                                <a class="btn btn-outline-dark btn-sm rounded"
                                                    href='{% url 'core:delete' project_id=project.id investigation_id=investigation_id data_type="data" pk=data|get_item:"id"  %}'><i
                                                        class="fas fa-trash-alt" aria-hidden="true"></i></a>
                                                {% else %}
                                                <div class="disabled-button-wrapper" data-toggle="popover" data-trigger="hover" data-placement="right"
                                                    title="Action not available" data-container="body" data-html="true"
                                                    data-content="You don't have sufficient permissions to  <br/> <strong>delete this data</strong>.">
                                                    <button class="btn btn-outline-dark btn-sm rounded" type="button" disabled><i
                                                            class="fas fa-trash-alt" aria-hidden="true"></i></button>
                                                </div>
                                                {% endif %}
                                                </h5>
                                            </li>
                                        {% endfor %}
                                        </ul>
                                    </ul>
                                </li>                
                        {% endfor %}
                    </ul>
                </ul>
            </div>
        </li>
            {% endfor %}
            {% endwith %}
            </ul>
        </ul>

    {% comment %} </div> {% endcomment %}
    
    {% endfor %}
    </li>
</ul>

openlink/core/templates/projects/list.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block content %}

<section>
    <h4 class="display-titre" style="cursor: default;">My projects</h4>

    <div class="row">
        <div class="col-sm-6">
            <span class="badge badge-pill badge-secondary">{{ filter.qs|length }}</span>
            <span class="texte-badge">projects found</span>
        </div>
        <div class="col-sm-6 text-right">
            <a class="add-link btn btn-primary" href="{% url 'core:projects-new' %}">Add project</a>
        </div>
    </div>

    <table id="table" class="table table-striped table-bordered table-hover">
        <thead>
            <tr>
                <th>Name</th>
                <th>Creation date</th>
                <th>Author</th>
                <th>Delete</th>
            </tr>
        </thead>
        <tbody>
            {% for project in filter.qs %}
            <tr>
                <td><i class="fa fa-laptop fa-1x laptop ic-w mx-1"></i><a
                        href="{% url 'core:projects-details' project.id %}">{{ project.name }}</a></td>
                <td>{{ project.date_created }}</td>
                <td>{{ project.author }}</td>
                <td><a href='projects/{{ project.id }}/delete/project/{{ project.id }}'><i
                            class="fa fa-times fa-1x"></i></a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</section>

<script>
    
    introJs().setOptions({
        dontShowAgain: true,
        dontShowAgainCookie: "introjs-dontShowAgain1",
        steps: [{
          title: 'Welcome to Openlink!',
          intro: 'Here you can find a list of your projects'
        },{
          element: document.querySelector('.add-link'),
          title: 'Create your first project!',
          intro: 'Start by adding a new project.'
        }
        ]
      }).start();
</script>

{% endblock %}